(function () {
    'use strict';

    class GameScene extends Core.Scene {
        constructor() { super(); }
        retrieveSceneName() { return "res/scenes/GameScene.json"; }
        init() {
            // start from here
        }
    }

    class LoadingScene extends Core.Scene {
        constructor() { super(); }
        retrieveSceneName() { return "res/scenes/LoadingScene.json"; }
        init() {
            const loader = this._loader = new Core.Loader();
            loader.once(LoaderEvent.LOAD_COMPLETE, this, this.onResourceLoaded);
            loader.on(LoaderEvent.LOAD_PROGRESS, this, this.onLoadProgress);
            loader.loadGroup("game");
        }
        onLoadProgress($e) {
            // $e.progress %
        }
        onResourceLoaded() {
            this.event(Laya.Event.COMPLETE);
        }
        destroy($destroyChild) {
            this._loader.off(LoaderEvent.LOAD_COMPLETE, this, this.onResourceLoaded);
            this._loader.off(LoaderEvent.LOAD_PROGRESS, this, this.onLoadProgress);
            super.destroy($destroyChild);
        }
    }

    class Game extends Core.Game {
        constructor() { super(); }
        retrieveLoadingScene() { return new LoadingScene(); }
        retrieveGameScene() { return new GameScene(); }
        async initPreloader() {
            await super.initPreloader();
            this.cetralizeScene(this._loadingUi);
        }
        async onResourceLoaded() {
            await super.onResourceLoaded();
            this.cetralizeScene(this._scene);
        }
        cetralizeScene($scene) {
            if ($scene.width > AppData.content.width) {
                $scene.x = (AppData.content.width - $scene.width) / 2;
            }
        }
    }

    /**This class is automatically generated by LayaAirIDE, please do not make any modifications. */
    /*
    * 游戏初始化配置;
    */
    class GameConfig {
        constructor() { }
        static init() {
            var reg = Laya.ClassUtils.regClass;
        }
    }
    GameConfig.width = 1334;
    GameConfig.height = 750;
    GameConfig.scaleMode = "fixedauto";
    GameConfig.screenMode = "none";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "res/scenes/LoadingScene.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    class LayaApp extends Core.GameApp {
        constructor() {
            super();
            //根据IDE设置初始化引擎		
            if (window["Laya3D"])
                Laya3D.init(GameConfig.width, GameConfig.height);
            else
                Laya.init(GameConfig.width, GameConfig.height, Laya.WebGL);
            Laya.Physics && Laya.Physics.enable();
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            this.initStage();
            //兼容微信不支持加载scene后缀场景
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            //打开调试面板（通过IDE设置调试模式，或者url地址增加debug=true参数，均可打开调试面板）
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") === "true")
                Laya.enableDebugPanel();
            if (GameConfig.physicsDebug && Laya.PhysicsDebugDraw)
                Laya.PhysicsDebugDraw.enable();
            if (GameConfig.stat)
                Laya.Stat.show();
            Laya.alertGlobalError = true;
            //激活资源版本控制，version.json由IDE发布功能自动生成，如果没有也不影响后续流程
            // Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
            this.init();
        }
        initStage() {
            Laya.stage.scaleMode = GameConfig.scaleMode;
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.stage.alignV = GameConfig.alignV;
            Laya.stage.alignH = GameConfig.alignH;
            AppData.content.width = GameConfig.width;
            AppData.content.height = GameConfig.height;
        }
        onVersionLoaded() {
            //激活大小图映射，加载小图的时候，如果发现小图在大图合集里面，则优先加载大图合集，而不是小图
            // Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
            this.init();
        }
    }

    class Main extends LayaApp {
        constructor() { super(); }
        retrieveGame() { return new Game(); }
        start() {
            if (BBL.Connector.activate()) {
                super.start();
                return;
            }
            else {
                ObjectUtil.deepMerge(BBL.Connector.data, Res.get("config").DEV.Connector);
                console.log("test");
                super.start();
            }
        }
    }
    new Main();

}());
